# Record Class CAI1TypeField

java.lang.Object
java.lang.Record
com.io7m.cardant.protocol.inventory.cb.CAI1TypeField

Record Components:
  `fieldName` - The type field name.
  `fieldDescription` - The type field description.
  `fieldType` - The type of the field.
  `fieldRequired` - Whether or not the field is required to be present.

All Implemented Interfaces:
  `com.io7m.cedarbridge.runtime.api.CBSerializableType`

public record CAI1TypeField(CAI1TypeRecordFieldIdentifier fieldName, com.io7m.cedarbridge.runtime.api.CBString fieldDescription, CAI1TypeScalar fieldType, com.io7m.cedarbridge.runtime.api.CBBooleanType fieldRequired) extends Record implements com.io7m.cedarbridge.runtime.api.CBSerializableType
A field within a type declaration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CAI1TypeField(CAI1TypeRecordFieldIdentifier fieldName, com.io7m.cedarbridge.runtime.api.CBString fieldDescription, CAI1TypeScalar fieldType, com.io7m.cedarbridge.runtime.api.CBBooleanType fieldRequired)`
  Creates an instance of a `CAI1TypeField` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static CAI1TypeField`
  `deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context)`
  Deserialize a value of type CAI1TypeField.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `com.io7m.cedarbridge.runtime.api.CBString`
  `fieldDescription()`
  Returns the value of the `fieldDescription` record component.
  `CAI1TypeRecordFieldIdentifier`
  `fieldName()`
  Returns the value of the `fieldName` record component.
  `com.io7m.cedarbridge.runtime.api.CBBooleanType`
  `fieldRequired()`
  Returns the value of the `fieldRequired` record component.
  `CAI1TypeScalar`
  `fieldType()`
  Returns the value of the `fieldType` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `static void`
  `serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, CAI1TypeField $x)`
  Serialize a value of type CAI1TypeField.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CAI1TypeField

    public CAI1TypeField(CAI1TypeRecordFieldIdentifier fieldName, com.io7m.cedarbridge.runtime.api.CBString fieldDescription, CAI1TypeScalar fieldType, com.io7m.cedarbridge.runtime.api.CBBooleanType fieldRequired)
    Creates an instance of a `CAI1TypeField` record class.
    Parameters:
      `fieldName` - the value for the `fieldName` record component
      `fieldDescription` - the value for the `fieldDescription` record component
      `fieldType` - the value for the `fieldType` record component
      `fieldRequired` - the value for the `fieldRequired` record component

- ## Method Details

  - ### serialize

    public static void serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, CAI1TypeField $x) throws IOException
    Serialize a value of type CAI1TypeField.
    Parameters:
      `$context` - The serialization context.
      `$x` - The value to be serialized.
    Throws:
      `IOException`

  - ### deserialize

    public static CAI1TypeField deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context) throws IOException
    Deserialize a value of type CAI1TypeField.
    Parameters:
      `$context` - The serialization context.
    Returns:
      A value of type CAI1TypeField.
    Throws:
      `IOException`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### fieldName

    public CAI1TypeRecordFieldIdentifier fieldName()
    Returns the value of the `fieldName` record component.
    Returns:
      the value of the `fieldName` record component

  - ### fieldDescription

    public com.io7m.cedarbridge.runtime.api.CBString fieldDescription()
    Returns the value of the `fieldDescription` record component.
    Returns:
      the value of the `fieldDescription` record component

  - ### fieldType

    public CAI1TypeScalar fieldType()
    Returns the value of the `fieldType` record component.
    Returns:
      the value of the `fieldType` record component

  - ### fieldRequired

    public com.io7m.cedarbridge.runtime.api.CBBooleanType fieldRequired()
    Returns the value of the `fieldRequired` record component.
    Returns:
      the value of the `fieldRequired` record component